﻿namespace UltraGridWinCalendarCombo
{
    using System;
    using System.Data;
    using System.Drawing;
    using System.Windows.Forms;

    using Infragistics.Win;
    using Infragistics.Win.UltraWinEditors;

    public partial class Form1 : Form
    {
        private DateTimeEditor editor;

        public Form1()
        {
            this.InitializeComponent();

            this.PopulateGridData();

            UltraDateTimeEditor ultraDateTimeEditor = new UltraDateTimeEditor();
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["Date"].EditorComponent = ultraDateTimeEditor;
            this.ultraGrid1.InitializeRow += this.UltraGrid1_InitializeRow;
        }

        private void UltraGrid1_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.InitializeRowEventArgs e)
        {
            if (this.editor == null)
            {
                this.editor = e.Row.Cells[1].EditorResolved as DateTimeEditor;
                this.editor.AfterDropDown += this.UltraDateTimeEditor1_AfterDropDown;
            }
        }

        private void UltraDateTimeEditor1_AfterDropDown(object sender, EventArgs e)
        {
            MonthCalendar cal = DropDownManager.GetCurrentDropDownControl(this.ultraGrid1) as MonthCalendar;
            cal.ShowWeekNumbers = true;

            cal.Parent.Bounds = new Rectangle(
                                                cal.Parent.Bounds.X - 23,
                                                cal.Parent.Bounds.Y,
                                                cal.Parent.Bounds.Width + 23,
                                                cal.Parent.Bounds.Height);
        }

        private void PopulateGridData()
        {
            DataSet dataSet = new DataSet();

            DataTable dataTable = dataSet.Tables.Add("table1");
            dataTable.Columns.Add("id", typeof(int)).AutoIncrement = true;
            dataTable.Columns.Add("Date", typeof(DateTime));

            dataSet.Tables["table1"].Rows.Add(new object[] { null, new DateTime(2008, 04, 22) });
            dataSet.Tables["table1"].Rows.Add(new object[] { null, new DateTime(2012, 05, 10) });
            dataSet.Tables["table1"].Rows.Add(new object[] { null, new DateTime(2005, 10, 05) });
            dataSet.Tables["table1"].Rows.Add(new object[] { null, new DateTime(2009, 02, 28) });
            dataSet.Tables["table1"].Rows.Add(new object[] { null, new DateTime(2008, 04, 22) });
            dataSet.Tables["table1"].Rows.Add(new object[] { null, new DateTime(2012, 05, 10) });
            dataSet.Tables["table1"].Rows.Add(new object[] { null, new DateTime(2005, 10, 05) });
            dataSet.Tables["table1"].Rows.Add(new object[] { null, new DateTime(2009, 02, 28) });
            dataSet.Tables["table1"].Rows.Add(new object[] { null, new DateTime(2008, 04, 22) });
            dataSet.Tables["table1"].Rows.Add(new object[] { null, new DateTime(2012, 05, 10) });
            dataSet.Tables["table1"].Rows.Add(new object[] { null, new DateTime(2005, 10, 05) });
            dataSet.Tables["table1"].Rows.Add(new object[] { null, new DateTime(2009, 02, 28) });
            dataSet.Tables["table1"].Rows.Add(new object[] { null, new DateTime(2008, 04, 22) });
            dataSet.Tables["table1"].Rows.Add(new object[] { null, new DateTime(2012, 05, 10) });
            dataSet.Tables["table1"].Rows.Add(new object[] { null, new DateTime(2005, 10, 05) });
            dataSet.Tables["table1"].Rows.Add(new object[] { null, new DateTime(2009, 02, 28) });

            ultraGrid1.DataSource = dataSet;
        }
    }
}
